function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from 'react';
import DownOutlined from '@ant-design/icons/DownOutlined';
import omit from 'omit.js';
import DropDown from '../dropdown/dropdown';
import { ConfigConsumer } from '../config-provider';

var BreadcrumbItem =
/** @class */
function () {
  var BreadcrumbItem = /*#__PURE__*/function (_React$Component) {
    _inherits(BreadcrumbItem, _React$Component);

    var _super = _createSuper(BreadcrumbItem);

    function BreadcrumbItem() {
      var _this;

      _classCallCheck(this, BreadcrumbItem);

      _this = _super.apply(this, arguments);

      _this.renderBreadcrumbItem = function (_ref) {
        var getPrefixCls = _ref.getPrefixCls;

        var _a = _this.props,
            customizePrefixCls = _a.prefixCls,
            separator = _a.separator,
            children = _a.children,
            restProps = __rest(_a, ["prefixCls", "separator", "children"]);

        var prefixCls = getPrefixCls('breadcrumb', customizePrefixCls);
        var link;

        if ('href' in _this.props) {
          link = /*#__PURE__*/React.createElement("a", _extends({
            className: "".concat(prefixCls, "-link")
          }, omit(restProps, ['overlay'])), children);
        } else {
          link = /*#__PURE__*/React.createElement("span", _extends({
            className: "".concat(prefixCls, "-link")
          }, omit(restProps, ['overlay'])), children);
        } // wrap to dropDown


        link = _this.renderBreadcrumbNode(link, prefixCls);

        if (children) {
          return /*#__PURE__*/React.createElement("span", null, link, separator && separator !== '' && /*#__PURE__*/React.createElement("span", {
            className: "".concat(prefixCls, "-separator")
          }, separator));
        }

        return null;
      };
      /**
       * if overlay is have
       * Wrap a DropDown
       */


      _this.renderBreadcrumbNode = function (breadcrumbItem, prefixCls) {
        var _this$props = _this.props,
            overlay = _this$props.overlay,
            dropdownProps = _this$props.dropdownProps;

        if (overlay) {
          return /*#__PURE__*/React.createElement(DropDown, _extends({
            overlay: overlay,
            placement: "bottomCenter"
          }, dropdownProps), /*#__PURE__*/React.createElement("span", {
            className: "".concat(prefixCls, "-overlay-link")
          }, breadcrumbItem, /*#__PURE__*/React.createElement(DownOutlined, null)));
        }

        return breadcrumbItem;
      };

      return _this;
    }

    _createClass(BreadcrumbItem, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement(ConfigConsumer, null, this.renderBreadcrumbItem);
      }
    }]);

    return BreadcrumbItem;
  }(React.Component);

  BreadcrumbItem.__ANT_BREADCRUMB_ITEM = true;
  BreadcrumbItem.defaultProps = {
    separator: '/'
  };
  return BreadcrumbItem;
}();

export default BreadcrumbItem;