function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from 'react';
import classNames from 'classnames';
import omit from 'omit.js';
import debounce from 'lodash/debounce';
import { ConfigConsumer } from '../config-provider';
import { tuple } from '../_util/type';
import { isValidElement, cloneElement } from '../_util/reactNode';
var SpinSizes = tuple('small', 'default', 'large'); // Render indicator

var defaultIndicator = null;

function renderIndicator(prefixCls, props) {
  var indicator = props.indicator;
  var dotClassName = "".concat(prefixCls, "-dot"); // should not be render default indicator when indicator value is null

  if (indicator === null) {
    return null;
  }

  if (isValidElement(indicator)) {
    return cloneElement(indicator, {
      className: classNames(indicator.props.className, dotClassName)
    });
  }

  if (isValidElement(defaultIndicator)) {
    return cloneElement(defaultIndicator, {
      className: classNames(defaultIndicator.props.className, dotClassName)
    });
  }

  return /*#__PURE__*/React.createElement("span", {
    className: classNames(dotClassName, "".concat(prefixCls, "-dot-spin"))
  }, /*#__PURE__*/React.createElement("i", {
    className: "".concat(prefixCls, "-dot-item")
  }), /*#__PURE__*/React.createElement("i", {
    className: "".concat(prefixCls, "-dot-item")
  }), /*#__PURE__*/React.createElement("i", {
    className: "".concat(prefixCls, "-dot-item")
  }), /*#__PURE__*/React.createElement("i", {
    className: "".concat(prefixCls, "-dot-item")
  }));
}

function shouldDelay(spinning, delay) {
  return !!spinning && !!delay && !isNaN(Number(delay));
}

var Spin =
/** @class */
function () {
  var Spin = /*#__PURE__*/function (_React$Component) {
    _inherits(Spin, _React$Component);

    var _super = _createSuper(Spin);

    function Spin(props) {
      var _this;

      _classCallCheck(this, Spin);

      _this = _super.call(this, props);

      _this.debouncifyUpdateSpinning = function (props) {
        var _ref = props || _this.props,
            delay = _ref.delay;

        if (delay) {
          _this.cancelExistingSpin();

          _this.updateSpinning = debounce(_this.originalUpdateSpinning, delay);
        }
      };

      _this.updateSpinning = function () {
        var spinning = _this.props.spinning;
        var currentSpinning = _this.state.spinning;

        if (currentSpinning !== spinning) {
          _this.setState({
            spinning: spinning
          });
        }
      };

      _this.renderSpin = function (_ref2) {
        var _classNames;

        var getPrefixCls = _ref2.getPrefixCls,
            direction = _ref2.direction;

        var _a = _this.props,
            customizePrefixCls = _a.prefixCls,
            className = _a.className,
            size = _a.size,
            tip = _a.tip,
            wrapperClassName = _a.wrapperClassName,
            style = _a.style,
            restProps = __rest(_a, ["prefixCls", "className", "size", "tip", "wrapperClassName", "style"]);

        var spinning = _this.state.spinning;
        var prefixCls = getPrefixCls('spin', customizePrefixCls);
        var spinClassName = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-sm"), size === 'small'), _defineProperty(_classNames, "".concat(prefixCls, "-lg"), size === 'large'), _defineProperty(_classNames, "".concat(prefixCls, "-spinning"), spinning), _defineProperty(_classNames, "".concat(prefixCls, "-show-text"), !!tip), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === 'rtl'), _classNames), className); // fix https://fb.me/react-unknown-prop

        var divProps = omit(restProps, ['spinning', 'delay', 'indicator']);
        var spinElement = /*#__PURE__*/React.createElement("div", _extends({}, divProps, {
          style: style,
          className: spinClassName
        }), renderIndicator(prefixCls, _this.props), tip ? /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-text")
        }, tip) : null);

        if (_this.isNestedPattern()) {
          var containerClassName = classNames("".concat(prefixCls, "-container"), _defineProperty({}, "".concat(prefixCls, "-blur"), spinning));
          return /*#__PURE__*/React.createElement("div", _extends({}, divProps, {
            className: classNames("".concat(prefixCls, "-nested-loading"), wrapperClassName)
          }), spinning && /*#__PURE__*/React.createElement("div", {
            key: "loading"
          }, spinElement), /*#__PURE__*/React.createElement("div", {
            className: containerClassName,
            key: "container"
          }, _this.props.children));
        }

        return spinElement;
      };

      var spinning = props.spinning,
          delay = props.delay;
      var shouldBeDelayed = shouldDelay(spinning, delay);
      _this.state = {
        spinning: spinning && !shouldBeDelayed
      };
      _this.originalUpdateSpinning = _this.updateSpinning;

      _this.debouncifyUpdateSpinning(props);

      return _this;
    }

    _createClass(Spin, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.updateSpinning();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this.debouncifyUpdateSpinning();
        this.updateSpinning();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.cancelExistingSpin();
      }
    }, {
      key: "cancelExistingSpin",
      value: function cancelExistingSpin() {
        var updateSpinning = this.updateSpinning;

        if (updateSpinning && updateSpinning.cancel) {
          updateSpinning.cancel();
        }
      }
    }, {
      key: "isNestedPattern",
      value: function isNestedPattern() {
        return !!(this.props && this.props.children);
      }
    }, {
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement(ConfigConsumer, null, this.renderSpin);
      }
    }], [{
      key: "setDefaultIndicator",
      value: function setDefaultIndicator(indicator) {
        defaultIndicator = indicator;
      }
    }]);

    return Spin;
  }(React.Component);

  Spin.defaultProps = {
    spinning: true,
    size: 'default',
    wrapperClassName: ''
  };
  return Spin;
}();

export default Spin;