function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from 'react';
import classNames from 'classnames';
import toArray from "rc-util/es/Children/toArray";
import findDOMNode from "rc-util/es/Dom/findDOMNode";
import copy from 'copy-to-clipboard';
import omit from 'omit.js';
import EditOutlined from '@ant-design/icons/EditOutlined';
import CheckOutlined from '@ant-design/icons/CheckOutlined';
import CopyOutlined from '@ant-design/icons/CopyOutlined';
import ResizeObserver from 'rc-resize-observer';
import { configConsumerProps } from '../config-provider';
import { withConfigConsumer } from '../config-provider/context';
import LocaleReceiver from '../locale-provider/LocaleReceiver';
import devWarning from '../_util/devWarning';
import TransButton from '../_util/transButton';
import raf from '../_util/raf';
import isStyleSupport from '../_util/styleChecker';
import Tooltip from '../tooltip';
import Typography from './Typography';
import Editable from './Editable';
import measure from './util';
var isLineClampSupport = isStyleSupport('webkitLineClamp');
var isTextOverflowSupport = isStyleSupport('textOverflow');

function wrapperDecorations(_ref, content) {
  var mark = _ref.mark,
      code = _ref.code,
      underline = _ref.underline,
      del = _ref["delete"],
      strong = _ref.strong;
  var currentContent = content;

  function wrap(needed, tag) {
    if (!needed) return;
    currentContent = React.createElement(tag, {}, currentContent);
  }

  wrap(strong, 'strong');
  wrap(underline, 'u');
  wrap(del, 'del');
  wrap(code, 'code');
  wrap(mark, 'mark');
  return currentContent;
}

var ELLIPSIS_STR = '...';

var Base =
/** @class */
function () {
  var Base = /*#__PURE__*/function (_React$Component) {
    _inherits(Base, _React$Component);

    var _super = _createSuper(Base);

    function Base() {
      var _this;

      _classCallCheck(this, Base);

      _this = _super.apply(this, arguments);
      _this.state = {
        edit: false,
        copied: false,
        ellipsisText: '',
        ellipsisContent: null,
        isEllipsis: false,
        expanded: false,
        clientRendered: false
      }; // =============== Expand ===============

      _this.onExpandClick = function (e) {
        var _this$getEllipsis = _this.getEllipsis(),
            onExpand = _this$getEllipsis.onExpand;

        _this.setState({
          expanded: true
        });

        if (onExpand) {
          onExpand(e);
        }
      }; // ================ Edit ================


      _this.onEditClick = function () {
        _this.triggerEdit(true);
      };

      _this.onEditChange = function (value) {
        var _this$getEditable = _this.getEditable(),
            onChange = _this$getEditable.onChange;

        if (onChange) {
          onChange(value);
        }

        _this.triggerEdit(false);
      };

      _this.onEditCancel = function () {
        _this.triggerEdit(false);
      }; // ================ Copy ================


      _this.onCopyClick = function () {
        var _this$props = _this.props,
            children = _this$props.children,
            copyable = _this$props.copyable;

        var copyConfig = _extends({}, _typeof(copyable) === 'object' ? copyable : null);

        if (copyConfig.text === undefined) {
          copyConfig.text = String(children);
        }

        copy(copyConfig.text || '');

        _this.setState({
          copied: true
        }, function () {
          if (copyConfig.onCopy) {
            copyConfig.onCopy();
          }

          _this.copyId = window.setTimeout(function () {
            _this.setState({
              copied: false
            });
          }, 3000);
        });
      };

      _this.setContentRef = function (node) {
        _this.content = node;
      };

      _this.setEditRef = function (node) {
        _this.editIcon = node;
      };

      _this.triggerEdit = function (edit) {
        var _this$getEditable2 = _this.getEditable(),
            onStart = _this$getEditable2.onStart;

        if (edit && onStart) {
          onStart();
        }

        _this.setState({
          edit: edit
        }, function () {
          if (!edit && _this.editIcon) {
            _this.editIcon.focus();
          }
        });
      }; // ============== Ellipsis ==============


      _this.resizeOnNextFrame = function () {
        raf.cancel(_this.rafId);
        _this.rafId = raf(function () {
          // Do not bind `syncEllipsis`. It need for test usage on prototype
          _this.syncEllipsis();
        });
      };

      return _this;
    }

    _createClass(Base, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.setState({
          clientRendered: true
        });
        this.resizeOnNextFrame();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var children = this.props.children;
        var ellipsis = this.getEllipsis();
        var prevEllipsis = this.getEllipsis(prevProps);

        if (children !== prevProps.children || ellipsis.rows !== prevEllipsis.rows) {
          this.resizeOnNextFrame();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        window.clearTimeout(this.copyId);
        raf.cancel(this.rafId);
      }
    }, {
      key: "getEditable",
      value: function getEditable(props) {
        var edit = this.state.edit;

        var _ref2 = props || this.props,
            editable = _ref2.editable;

        if (!editable) return {
          editing: edit
        };
        return _extends({
          editing: edit
        }, _typeof(editable) === 'object' ? editable : null);
      }
    }, {
      key: "getEllipsis",
      value: function getEllipsis(props) {
        var _ref3 = props || this.props,
            ellipsis = _ref3.ellipsis;

        if (!ellipsis) return {};
        return _extends({
          rows: 1,
          expandable: false
        }, _typeof(ellipsis) === 'object' ? ellipsis : null);
      }
    }, {
      key: "canUseCSSEllipsis",
      value: function canUseCSSEllipsis() {
        var clientRendered = this.state.clientRendered;
        var _this$props2 = this.props,
            editable = _this$props2.editable,
            copyable = _this$props2.copyable;

        var _this$getEllipsis2 = this.getEllipsis(),
            rows = _this$getEllipsis2.rows,
            expandable = _this$getEllipsis2.expandable,
            suffix = _this$getEllipsis2.suffix,
            onEllipsis = _this$getEllipsis2.onEllipsis;

        if (suffix) return false; // Can't use css ellipsis since we need to provide the place for button

        if (editable || copyable || expandable || !clientRendered || onEllipsis) {
          return false;
        }

        if (rows === 1) {
          return isTextOverflowSupport;
        }

        return isLineClampSupport;
      }
    }, {
      key: "syncEllipsis",
      value: function syncEllipsis() {
        var _this$state = this.state,
            ellipsisText = _this$state.ellipsisText,
            isEllipsis = _this$state.isEllipsis,
            expanded = _this$state.expanded;

        var _this$getEllipsis3 = this.getEllipsis(),
            rows = _this$getEllipsis3.rows,
            suffix = _this$getEllipsis3.suffix,
            onEllipsis = _this$getEllipsis3.onEllipsis;

        var children = this.props.children;
        if (!rows || rows < 0 || !this.content || expanded) return; // Do not measure if css already support ellipsis

        if (this.canUseCSSEllipsis()) return;
        devWarning(toArray(children).every(function (child) {
          return typeof child === 'string';
        }), 'Typography', '`ellipsis` should use string as children only.');

        var _measure = measure(findDOMNode(this.content), {
          rows: rows,
          suffix: suffix
        }, children, this.renderOperations(true), ELLIPSIS_STR),
            content = _measure.content,
            text = _measure.text,
            ellipsis = _measure.ellipsis;

        if (ellipsisText !== text || isEllipsis !== ellipsis) {
          this.setState({
            ellipsisText: text,
            ellipsisContent: content,
            isEllipsis: ellipsis
          });

          if (isEllipsis !== ellipsis && onEllipsis) {
            onEllipsis(ellipsis);
          }
        }
      }
    }, {
      key: "renderExpand",
      value: function renderExpand(forceRender) {
        var _this$getEllipsis4 = this.getEllipsis(),
            expandable = _this$getEllipsis4.expandable;

        var prefixCls = this.props.prefixCls;
        var _this$state2 = this.state,
            expanded = _this$state2.expanded,
            isEllipsis = _this$state2.isEllipsis;
        if (!expandable) return null; // force render expand icon for measure usage or it will cause dead loop

        if (!forceRender && (expanded || !isEllipsis)) return null;
        return /*#__PURE__*/React.createElement("a", {
          key: "expand",
          className: "".concat(prefixCls, "-expand"),
          onClick: this.onExpandClick,
          "aria-label": this.expandStr
        }, this.expandStr);
      }
    }, {
      key: "renderEdit",
      value: function renderEdit() {
        var _this$props3 = this.props,
            editable = _this$props3.editable,
            prefixCls = _this$props3.prefixCls;
        if (!editable) return;
        return /*#__PURE__*/React.createElement(Tooltip, {
          key: "edit",
          title: this.editStr
        }, /*#__PURE__*/React.createElement(TransButton, {
          ref: this.setEditRef,
          className: "".concat(prefixCls, "-edit"),
          onClick: this.onEditClick,
          "aria-label": this.editStr
        }, /*#__PURE__*/React.createElement(EditOutlined, {
          role: "button"
        })));
      }
    }, {
      key: "renderCopy",
      value: function renderCopy() {
        var copied = this.state.copied;
        var _this$props4 = this.props,
            copyable = _this$props4.copyable,
            prefixCls = _this$props4.prefixCls;
        if (!copyable) return;
        var title = copied ? this.copiedStr : this.copyStr;
        return /*#__PURE__*/React.createElement(Tooltip, {
          key: "copy",
          title: title
        }, /*#__PURE__*/React.createElement(TransButton, {
          className: classNames("".concat(prefixCls, "-copy"), copied && "".concat(prefixCls, "-copy-success")),
          onClick: this.onCopyClick,
          "aria-label": title
        }, copied ? /*#__PURE__*/React.createElement(CheckOutlined, null) : /*#__PURE__*/React.createElement(CopyOutlined, null)));
      }
    }, {
      key: "renderEditInput",
      value: function renderEditInput() {
        var _this$props5 = this.props,
            children = _this$props5.children,
            prefixCls = _this$props5.prefixCls,
            className = _this$props5.className,
            style = _this$props5.style,
            direction = _this$props5.direction;
        return /*#__PURE__*/React.createElement(Editable, {
          value: typeof children === 'string' ? children : '',
          onSave: this.onEditChange,
          onCancel: this.onEditCancel,
          prefixCls: prefixCls,
          className: className,
          style: style,
          direction: direction
        });
      }
    }, {
      key: "renderOperations",
      value: function renderOperations(forceRenderExpanded) {
        return [this.renderExpand(forceRenderExpanded), this.renderEdit(), this.renderCopy()].filter(function (node) {
          return node;
        });
      }
    }, {
      key: "renderContent",
      value: function renderContent() {
        var _this2 = this;

        var _this$state3 = this.state,
            ellipsisContent = _this$state3.ellipsisContent,
            isEllipsis = _this$state3.isEllipsis,
            expanded = _this$state3.expanded;

        var _a = this.props,
            component = _a.component,
            children = _a.children,
            className = _a.className,
            prefixCls = _a.prefixCls,
            type = _a.type,
            disabled = _a.disabled,
            style = _a.style,
            title = _a.title,
            restProps = __rest(_a, ["component", "children", "className", "prefixCls", "type", "disabled", "style", "title"]);

        var _this$getEllipsis5 = this.getEllipsis(),
            rows = _this$getEllipsis5.rows,
            suffix = _this$getEllipsis5.suffix;

        var textProps = omit(restProps, ['prefixCls', 'editable', 'copyable', 'ellipsis', 'mark', 'underline', 'mark', 'code', 'delete', 'underline', 'strong'].concat(_toConsumableArray(configConsumerProps)));
        var cssEllipsis = this.canUseCSSEllipsis();
        var cssTextOverflow = rows === 1 && cssEllipsis;
        var cssLineClamp = rows && rows > 1 && cssEllipsis;
        var textNode = children;
        var ariaLabel; // Only use js ellipsis when css ellipsis not support

        if (rows && isEllipsis && !expanded && !cssEllipsis) {
          ariaLabel = title;

          if (!title && (typeof children === 'string' || typeof children === 'number')) {
            ariaLabel = String(children);
          } // We move full content to outer element to avoid repeat read the content by accessibility


          textNode = /*#__PURE__*/React.createElement("span", {
            title: ariaLabel,
            "aria-hidden": "true"
          }, ellipsisContent, ELLIPSIS_STR, suffix);
        } else {
          textNode = /*#__PURE__*/React.createElement(React.Fragment, null, children, suffix);
        }

        textNode = wrapperDecorations(this.props, textNode);
        return /*#__PURE__*/React.createElement(LocaleReceiver, {
          componentName: "Text"
        }, function (_ref4) {
          var _classNames;

          var edit = _ref4.edit,
              copyStr = _ref4.copy,
              copied = _ref4.copied,
              expand = _ref4.expand;
          _this2.editStr = edit;
          _this2.copyStr = copyStr;
          _this2.copiedStr = copied;
          _this2.expandStr = expand;
          return /*#__PURE__*/React.createElement(ResizeObserver, {
            onResize: _this2.resizeOnNextFrame,
            disabled: !rows
          }, /*#__PURE__*/React.createElement(Typography, _extends({
            className: classNames(className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(type), type), _defineProperty(_classNames, "".concat(prefixCls, "-disabled"), disabled), _defineProperty(_classNames, "".concat(prefixCls, "-ellipsis"), rows), _defineProperty(_classNames, "".concat(prefixCls, "-ellipsis-single-line"), cssTextOverflow), _defineProperty(_classNames, "".concat(prefixCls, "-ellipsis-multiple-line"), cssLineClamp), _classNames)),
            style: _extends(_extends({}, style), {
              WebkitLineClamp: cssLineClamp ? rows : null
            }),
            component: component,
            ref: _this2.setContentRef,
            "aria-label": ariaLabel
          }, textProps), textNode, _this2.renderOperations()));
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this$getEditable3 = this.getEditable(),
            editing = _this$getEditable3.editing;

        if (editing) {
          return this.renderEditInput();
        }

        return this.renderContent();
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(nextProps) {
        var children = nextProps.children,
            editable = nextProps.editable;
        devWarning(!editable || typeof children === 'string', 'Typography', 'When `editable` is enabled, the `children` should use string.');
        return {};
      }
    }]);

    return Base;
  }(React.Component);

  Base.defaultProps = {
    children: ''
  };
  return Base;
}();

export default withConfigConsumer({
  prefixCls: 'typography'
})(Base);