"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

var _rcTabs = _interopRequireWildcard(require("rc-tabs"));

var _TabContent = _interopRequireDefault(require("rc-tabs/lib/TabContent"));

var _classnames = _interopRequireDefault(require("classnames"));

var _omit = _interopRequireDefault(require("omit.js"));

var _CloseOutlined = _interopRequireDefault(require("@ant-design/icons/CloseOutlined"));

var _PlusOutlined = _interopRequireDefault(require("@ant-design/icons/PlusOutlined"));

var _TabBar = _interopRequireDefault(require("./TabBar"));

var _configProvider = require("../config-provider");

var _styleChecker = require("../_util/styleChecker");

var _reactNode = require("../_util/reactNode");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var Tabs =
/** @class */
function () {
  var Tabs = /*#__PURE__*/function (_React$Component) {
    _inherits(Tabs, _React$Component);

    var _super = _createSuper(Tabs);

    function Tabs() {
      var _this;

      _classCallCheck(this, Tabs);

      _this = _super.apply(this, arguments);

      _this.removeTab = function (targetKey, e) {
        e.stopPropagation();

        if (!targetKey) {
          return;
        }

        var onEdit = _this.props.onEdit;

        if (onEdit) {
          onEdit(targetKey, 'remove');
        }
      };

      _this.handleChange = function (activeKey) {
        var onChange = _this.props.onChange;

        if (onChange) {
          onChange(activeKey);
        }
      };

      _this.createNewTab = function (targetKey) {
        var onEdit = _this.props.onEdit;

        if (onEdit) {
          onEdit(targetKey, 'add');
        }
      };

      _this.renderTabs = function (_ref) {
        var _classNames;

        var getPrefixCls = _ref.getPrefixCls,
            direction = _ref.direction;
        var _this$props = _this.props,
            customizePrefixCls = _this$props.prefixCls,
            _this$props$className = _this$props.className,
            className = _this$props$className === void 0 ? '' : _this$props$className,
            size = _this$props.size,
            _this$props$type = _this$props.type,
            type = _this$props$type === void 0 ? 'line' : _this$props$type,
            tabPosition = _this$props.tabPosition,
            children = _this$props.children,
            _this$props$animated = _this$props.animated,
            animated = _this$props$animated === void 0 ? true : _this$props$animated,
            hideAdd = _this$props.hideAdd;
        var tabBarExtraContent = _this.props.tabBarExtraContent;
        var tabPaneAnimated = _typeof(animated) === 'object' ? animated.tabPane : animated; // card tabs should not have animation

        if (type !== 'line') {
          tabPaneAnimated = 'animated' in _this.props ? tabPaneAnimated : false;
        }

        var prefixCls = getPrefixCls('tabs', customizePrefixCls);
        var cls = (0, _classnames["default"])(className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-vertical"), tabPosition === 'left' || tabPosition === 'right'), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(size), !!size), _defineProperty(_classNames, "".concat(prefixCls, "-card"), type.indexOf('card') >= 0), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(type), true), _defineProperty(_classNames, "".concat(prefixCls, "-no-animation"), !tabPaneAnimated), _classNames)); // only card type tabs can be added and closed

        var childrenWithClose = [];

        if (type === 'editable-card') {
          childrenWithClose = [];
          React.Children.forEach(children, function (child, index) {
            if (!(0, _reactNode.isValidElement)(child)) return child;
            var closable = child.props.closable;
            closable = typeof closable === 'undefined' ? true : closable;
            var closeIcon = closable ? /*#__PURE__*/React.createElement(_CloseOutlined["default"], {
              className: "".concat(prefixCls, "-close-x"),
              onClick: function onClick(e) {
                return _this.removeTab(child.key, e);
              }
            }) : null;
            childrenWithClose.push((0, _reactNode.cloneElement)(child, {
              tab: /*#__PURE__*/React.createElement("div", {
                className: closable ? undefined : "".concat(prefixCls, "-tab-unclosable")
              }, child.props.tab, closeIcon),
              key: child.key || index
            }));
          }); // Add new tab handler

          if (!hideAdd) {
            tabBarExtraContent = /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(_PlusOutlined["default"], {
              className: "".concat(prefixCls, "-new-tab"),
              onClick: _this.createNewTab
            }), tabBarExtraContent);
          }
        }

        tabBarExtraContent = tabBarExtraContent ? /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-extra-content")
        }, tabBarExtraContent) : null;

        var tabBarProps = __rest(_this.props, []);

        var contentCls = (0, _classnames["default"])("".concat(prefixCls, "-").concat(tabPosition, "-content"), type.indexOf('card') >= 0 && "".concat(prefixCls, "-card-content"));
        return /*#__PURE__*/React.createElement(_rcTabs["default"], _extends({}, _this.props, {
          prefixCls: prefixCls,
          className: cls,
          tabBarPosition: tabPosition,
          direction: direction,
          renderTabBar: function renderTabBar() {
            return /*#__PURE__*/React.createElement(_TabBar["default"], _extends({}, (0, _omit["default"])(tabBarProps, ['className']), {
              tabBarExtraContent: tabBarExtraContent
            }));
          },
          renderTabContent: function renderTabContent() {
            return /*#__PURE__*/React.createElement(_TabContent["default"], {
              className: contentCls,
              animated: tabPaneAnimated,
              animatedWithMargin: true
            });
          },
          onChange: _this.handleChange
        }), childrenWithClose.length > 0 ? childrenWithClose : children);
      };

      return _this;
    }

    _createClass(Tabs, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var NO_FLEX = ' no-flex';
        var tabNode = ReactDOM.findDOMNode(this);

        if (tabNode && !_styleChecker.isFlexSupported && tabNode.className.indexOf(NO_FLEX) === -1) {
          tabNode.className += NO_FLEX;
        }
      }
    }, {
      key: "render",
      value: function render() {
        return /*#__PURE__*/React.createElement(_configProvider.ConfigConsumer, null, this.renderTabs);
      }
    }]);

    return Tabs;
  }(React.Component);

  Tabs.TabPane = _rcTabs.TabPane;
  Tabs.defaultProps = {
    hideAdd: false,
    tabPosition: 'top'
  };
  return Tabs;
}();

var _default = Tabs;
exports["default"] = _default;